 indexing
	description: "Main window of the DirectX8 Application"

	author: "Hubert Cater"
	date: "Date: February 1, 2009"

class
	MAIN_WINDOW

inherit

	WEL_FRAME_WINDOW
		rename
        	dispose as frame_window_dispose,
        	out as wel_frame_window_out
		end

	ECOM_EXCEPTION
		export
			{NONE} all
		redefine dispose
		select dispose, out
		end

create
	make

feature -- Initialization

	make is
		-- make the main window
		local
			mode : D3_DDISPLAYMODE_RECORD
			presentation : D3_DPRESENT_PARAMETERS_RECORD
		do
			-- main window
			make_top("")

			-- initialize the directx8 component
			create dx.make

			-- create direct3d
			d3d ?= dx.direct3_dcreate

			-- create d3dx8
			create d3dx8.make

			-- create the display mode
			create mode.make
			d3d.get_adapter_display_mode ({ECOM_CONST_D3_DCONST_ENUM}.d3_dadapter_default, mode)

			-- create the presentation parameters
			create presentation.make
			presentation.set_windowed (1)
			presentation.set_swap_effect ({ECOM_CONST_D3_DSWAPEFFECT_ENUM}.d3_dswapeffect_discard)
			presentation.set_back_buffer_format (mode.format)
			presentation.set_h_device_window (Current.to_integer)
			presentation.set_back_buffer_width (Current.width)
			presentation.set_back_buffer_height (Current.height)
			presentation.set_back_buffer_count (1)

			-- create direct3d device
			d3d_device ?= d3d.create_device ({ECOM_CONST_D3_DCONST_ENUM}.d3_dadapter_default, {ECOM_CONST_D3_DDEVTYPE_ENUM}.d3_ddevtype_hal, Current.to_integer, {ECOM_CONST_D3_DCREATEFLAGS_ENUM}.d3_dcreate_software_vertexprocessing, presentation)

			-- create sprite
			d3dxs ?= d3dx8.create_sprite (d3d_device)

		end

feature {NONE} -- Dispose

	dispose is
		do
			Precursor {ECOM_EXCEPTION}
			frame_window_dispose
		end

feature {NONE} -- DirectX8 Objects

	dx : DIRECT_X8_PROXY
		-- main directx8 object

	d3d : DIRECT3_D8_IMPL_PROXY

	d3dx8 : D3_DX8_PROXY

	d3d_device : DIRECT3_DDEVICE8_IMPL_PROXY

	texture : DIRECT3_DTEXTURE8_IMPL_PROXY

	d3dxs : D3_DXSPRITE_IMPL_PROXY

end -- class MAIN_WINDOW
